#include "fl_contrl_sys.h"
#include "processes.h"
#include "p_blackboard.h"

// Task's parameters table:
PROCESS_ATTRIBUTE_TYPE proc_table[NO_OF_PROCESSES]=
{ 
		// NAME, 					ENTRY_POINT, 	STACK_SIZE, BASE_PRIORITY, PERIOD, TIME_CAPACITY, DADLINE
		{"Handling_Control",		(FUNCPTR)Handling_Control,			4096,100,100,100,100},
		{"Pitch_Stabilization",		(FUNCPTR)Pitch_Stabilization,		4096,100,100,100,100},
		{"Actuator_Synchronization",(FUNCPTR)Actuator_Synchronization,	4096,100,100,100,100},
		{"Actuator_Controller1",	(FUNCPTR)Actuator_Controller1,		4096,100,100,100,100},
		{"Actuator_Controller2",	(FUNCPTR)Actuator_Controller2,		4096,100,100,100,100},
		//{"MW1",MW1,4096,100,100,100,100},
		//{"MW2",MW2,4096,100,100,100,100},
		{"Actuator_Dynamics",		(FUNCPTR)Actuator_Dynamics,			4096,100,100,100,100},
		{"Aircraft_Dynamics",		(FUNCPTR)Aircraft_Dynamics,			4096,100,100,100,100},
		{"Pilot_Steering",			(FUNCPTR)Pilot_Steering,			4096,100,100,100,100}
};

// Blcakboard's data table:
P_BALCKBOARD_DATA blackboard_table[NO_OF_P_BLACKBOARDS]=
{
		{"Up",0,0.0},		//1
		{"THM",0,0.0},		//2
		{"Upf",0,0.0},		//3
		{"THD",0,0.0},		//4
		{"qm",0,0.0},		//5
		{"Dhm",0,0.0},		//6
		{"Dhd",0,0.0},		//7
		{"Dhd1",0,0.0},		//8
		{"Dhd2",0,0.0},		//9
		{"MA1",0,0.0},		//10
		{"MA2",0,0.0},		//11
		{"p1",0,0.0},		//12
		{"p2",0,0.0},		//13
		{"",0,0.0},			// backup
		{"",0,0.0},			// backup
		{"",0,0.0}			// backup
};

// Task's IDs table:
int TaskID[NO_OF_PROCESSES];

// Watchdog IDs table:
WDOG_ID WatchdogID[NO_OF_PROCESSES];


// Task init function:
void init_tasks(void)
{
	int i;
	// Set task basic period:
	
	proc_table[T_HC].PERIOD=sysClkRateGet()/1; //(1Hz)
	proc_table[T_PS].PERIOD=sysClkRateGet()/1; //(1Hz)
	proc_table[T_AS].PERIOD=sysClkRateGet()/1; //(1Hz)
	proc_table[T_AC1].PERIOD=sysClkRateGet()/1; //(1Hz)
	proc_table[T_AC2].PERIOD=sysClkRateGet()/1; //(1Hz)
	proc_table[T_AR].PERIOD=sysClkRateGet()/1; //(1Hz)
	proc_table[T_DA].PERIOD=sysClkRateGet()/1; //(1Hz)
	proc_table[T_PT].PERIOD=sysClkRateGet()/1; //(1Hz)
	
	
	// Automatic process init:
	/*
	for(i=0;i<NO_OF_PROCESSES;i++)
	{
		TaskID[i]=
			taskSpawn(	proc_table[i].NAME,
						proc_table[i].BASE_PRIORITY,
						0,
						proc_table[i].STACK_SIZE,
						(FUNCPTR)proc_table[i].ENTRY_POINT,
						0,0,0,0,0,0,0,0,0,0);
		if(TaskID[i]==ERROR)
		{
			printf("Blad inicjalizacji zadania %d",i);
			exit(0);
		}
	}
	*/
	// "Manual process init:
	// 
	TaskID[T_HC]=
			taskSpawn(	proc_table[T_HC].NAME,
						proc_table[T_HC].BASE_PRIORITY,
						0,
						proc_table[T_HC].STACK_SIZE,
						(FUNCPTR)proc_table[T_HC].ENTRY_POINT,
						0,0,0,0,0,0,0,0,0,0);
		if(TaskID[T_HC]==ERROR)
		{
			printf("Task %d initialization error",i);
			exit(0);
		}
		
	TaskID[T_PS]=
				taskSpawn(	proc_table[T_PS].NAME,
							proc_table[T_PS].BASE_PRIORITY,
							0,
							proc_table[T_PS].STACK_SIZE,
							(FUNCPTR)proc_table[T_PS].ENTRY_POINT,
							0,0,0,0,0,0,0,0,0,0);
		if(TaskID[T_PS]==ERROR)
		{
			printf("Task %d initialization error",i);
			exit(0);
		}

	TaskID[T_AS]=
				taskSpawn(	proc_table[T_AS].NAME,
							proc_table[T_AS].BASE_PRIORITY,
							0,
							proc_table[T_AS].STACK_SIZE,
							(FUNCPTR)proc_table[T_AS].ENTRY_POINT,
							0,0,0,0,0,0,0,0,0,0);
		if(TaskID[T_AS]==ERROR)
		{
			printf("Task %d initialization error",i);
			exit(0);
		}

	TaskID[T_AC1]=
				taskSpawn(	proc_table[T_AC1].NAME,
							proc_table[T_AC1].BASE_PRIORITY,
							0,
							proc_table[T_AC1].STACK_SIZE,
							(FUNCPTR)proc_table[T_AC1].ENTRY_POINT,
							0,0,0,0,0,0,0,0,0,0);
		if(TaskID[T_AC1]==ERROR)
		{
			printf("Task %d initialization error",i);
			exit(0);
		}

	TaskID[T_AC2]=
				taskSpawn(	proc_table[T_AC2].NAME,
							proc_table[T_AC2].BASE_PRIORITY,
							0,
							proc_table[T_AC2].STACK_SIZE,
							(FUNCPTR)proc_table[T_AC2].ENTRY_POINT,
							0,0,0,0,0,0,0,0,0,0);
		if(TaskID[T_AC2]==ERROR)
		{
			printf("Task %d initialization error",i);
			exit(0);
		}

	TaskID[T_AR]=
				taskSpawn(	proc_table[T_AR].NAME,
							proc_table[T_AR].BASE_PRIORITY,
							0,
							proc_table[T_AR].STACK_SIZE,
							(FUNCPTR)proc_table[T_AR].ENTRY_POINT,
							0,0,0,0,0,0,0,0,0,0);
		if(TaskID[T_AR]==ERROR)
		{
			printf("Task %d initialization error",i);
			exit(0);
		}

	TaskID[T_DA]=
				taskSpawn(	proc_table[T_DA].NAME,
							proc_table[T_DA].BASE_PRIORITY,
							0,
							proc_table[T_DA].STACK_SIZE,
							(FUNCPTR)proc_table[T_DA].ENTRY_POINT,
							0,0,0,0,0,0,0,0,0,0);
		if(TaskID[T_DA]==ERROR)
		{
			printf("Blad inicjalizacji zadania %d",i);
			exit(0);
		}

	TaskID[T_PT]=
				taskSpawn(	proc_table[T_PT].NAME,
							proc_table[T_PT].BASE_PRIORITY,
							0,
							proc_table[T_PT].STACK_SIZE,
							(FUNCPTR)proc_table[T_PT].ENTRY_POINT,
							0,0,0,0,0,0,0,0,0,0);
		if(TaskID[T_PT]==ERROR)
		{
			printf("Blad inicjalizacji zadania %d",i);
			exit(0);
		}
}


// Inicjalizacja watchdogs:
void init_watchdogs(void)
{
	int i;
	for(i=0;i<NO_OF_PROCESSES;i++)
		{
		if ((WatchdogID[i] = wdCreate()) == NULL)
			{	printf("Blad inicajlizacji watchdog%d",i);
				exit(0);
			}
		}
}


void init_p_blackboards(void)
{
	int i;
	float init_val = 10.0;
	for(i=0;i<NO_OF_P_BLACKBOARDS ;i++)
	{
		P_CREATE_BLACKBOARD(i);
	}

	for(i=0;i<NO_OF_P_BLACKBOARDS ;i++)
		{
			P_DISPLAY_BLACKBOARD(i,&init_val);
		}
	//for(i=0;i<NO_OF_P_BLACKBOARDS ;i++)
	//	{
	//	 printf("%s, %d, %f\n",
	//			 blackboard_table[i].NAME,
	//			 (int)(blackboard_table[i].MUTEX_ID),
	//			 blackboard_table[i].DATA
	//			);
	//	}
	
}

// tool functions:
//------------------------------------------------------------------------------------------
void display_blackboards(void)
{
	int i;
	while(1)
	{
	for(i=0;i<NO_OF_P_BLACKBOARDS ;i++)
			{
			 printf("%s\t%d\t%f\n",
					 blackboard_table[i].NAME,
					 (int)(blackboard_table[i].MUTEX_ID),
					 blackboard_table[i].DATA
					);
			}
			printf("-------------------------------------\n");
	taskDelay(sysClkRateGet()*3);
	}
}

void init_display_blackboards(void)
{
	taskSpawn("disp_black",80,0,4096,(FUNCPTR)display_blackboards,0,0,0,0,0,0,0,0,0,0);
}
//-------------------------------------------------------------------------------------------



void main(void)
{
	init_watchdogs();
	init_p_blackboards();
	init_tasks();
	init_display_blackboards();
	
	taskSuspend(0);
}









